#include "bussim_global.h"
#include "bussim_extern.h"

#include <iostream>
#include <stdio.h>
#include <string>
#include <cmath>

//#include <freeglut/freeglut.h>

using namespace std;

/*extern int TASTE_GEDRUECKT;
extern int AUTOMATIC_MODE;
extern class BUSSIM_NETWORK NET;
extern int BETRIEBSENDE;
extern int SHOW_INFRASTRUCTURE;
extern int SHOW_STOPS;
extern int SHOW_LINES;
extern double *DeltaT;
extern int GLOBAL_COUNTER;
*/

extern class BUSSIM_NETWORK NET;
//extern int argc;
//extern char **argv;

extern GLint WindowMain;
extern GLint WindowVehicles;
extern GLint WindowPaxes;

// the global variables that control the simulation
long GLOBAL_COUNTER = 0;
int TASTE_GEDRUECKT = 1;
int BETRIEBSENDE = 0;
int AUTOMATIC_MODE = 0;
int SHOW_INFRASTRUCTURE = 0;
int SHOW_STOPS = 0;
int SHOW_LINES = 1;
int SHOW_LINE_AGENDA = BUSSIM_SHOW_LINE_AGENDA;
int SHOW_ACTIVE_VEHICLES = BUSSIM_SHOW_ACTIVE_VEHICLES;
int SHOW_MENUE = 1;
int SHOW_BUNCHES = BUSSIM_SHOW_BUNCHES;
int MOVE_CAMERA_POSITION = 0;
int MODIFY_ZOOM = 0;
int SHOW_NETWORKSTATISTICS = 0;
int SHOW_TOIS = BUSSIM_SHOW_TOI;    // from V 1.05
int SHOW_DIRECTION_INDICATORS = 0;  // from V 1.05
int SHOW_QUEUES = 0;                // from V 1.05
int DISPLAY_VEHICLE_LABELS = BUSSIM_SHOW_VEHICLE_LABELS;    // from V 3.00
int DISPLAY_VEHICLES = 1;           // from V 3.00
int SHOW_BG = BUSSIM_BGFILE_ONSTART;                    // from V 3.00
int SHOW_AUX_STOPS = 0;
int SHOW_AUX_STOPS_LABELS = 0;
int SHOW_ARROW_HEADS = 0;           // from V3.00

int SHOW_ALSO_TRANSFER_ARCS = 0;    // from V3.00
int PRINT_SHORT_NODE_LABELS = 1;

int SHOW_ARC_LABELS = 0;            // from V3.00

double MENUE_OFFSET_X = 0.0;
double MENUE_OFFSET_Y = 0.0;

void set_simulation_window(void)
{
    // specify the design and position of the main window
    glutInitWindowSize(BUSSIM_WINDOWS_SIZE_X, BUSSIM_WINDOWS_SIZE_Y);
    glutInitWindowPosition(0, 0);
    WindowMain = glutCreateWindow("BuSSIM V 3.00");

    // specify the design and position of the vehicle window
    glutInitWindowSize(500, 1000);
    glutInitWindowPosition(BUSSIM_WINDOWS_SIZE_X+10, 0);
    WindowVehicles = glutCreateWindow("vehicles");

    if( BUSSIM_SHOW_PAX_WINDOW > 0 )
    {
        // specify the design and position of the vehicle window
        glutInitWindowSize(500, 1000);
        glutInitWindowPosition(BUSSIM_WINDOWS_SIZE_X+500+10, 0);
        WindowPaxes = glutCreateWindow("passengers");
    }
    glutSetWindow(WindowMain);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glOrtho(-1, 1, -1, 1, -1, 1);

    glMatrixMode(GL_MODELVIEW);

    glScalef(1.00,1.00,1);

    // restore the view from the last start
    NET.load_vp_move_list();

    glPushMatrix();
    glDrawBuffer(GL_MODELVIEW);
}

void set_callback_funcs(void)
{
    glutSetWindow(WindowMain);
    glutDisplayFunc(display);
    glutKeyboardFunc(tasten);
    glutTimerFunc(10, time_loop, 3 /* stupid value to pass to func. */);

    glutSetWindow(WindowVehicles);
    glutDisplayFunc(display_vehicles);

    if( BUSSIM_SHOW_PAX_WINDOW > 0 )
    {
        glutSetWindow(WindowPaxes);
        glutDisplayFunc(display_paxes);
    }

}

// this is the vehicle screen update method
void display_vehicles(void)
{
    glutSetWindow(WindowVehicles);

    // update displayed information
    char TitleVehicles[256];
    sprintf(TitleVehicles,"Vehicle Fleet at Time %.1f",NET.CURRENT_TIME);
    glutSetWindowTitle(TitleVehicles);

    //Clear all pixels
    glClearColor(BUSSIM_BGCOLOR_VEHICLES_RED,BUSSIM_BGCOLOR_VEHICLES_GREEN,BUSSIM_BGCOLOR_VEHICLES_BLUE,0.0);
    glClear(GL_COLOR_BUFFER_BIT);

    // set the background color
    glColor4f(0.0f, 1.0f, 0.0f, 0.0f);

    // show the list of active vehicles
    NET.display_active_vehicles();

    // mark the vehicle screen as in need for update
    glFlush();

    // come back to the main window
    glutSetWindow(WindowMain);
}

// this is the vehicle screen update method
void display_vehicles_orig(void)
{
    glutSetWindow(WindowVehicles);

    // update displayed information
    char TitleVehicles[256];
    sprintf(TitleVehicles,"Vehicle Fleet at Time %.1f",NET.CURRENT_TIME);
    glutSetWindowTitle(TitleVehicles);

    //Clear all pixels
    glClearColor(BUSSIM_BGCOLOR_VEHICLES_RED,BUSSIM_BGCOLOR_VEHICLES_GREEN,BUSSIM_BGCOLOR_VEHICLES_BLUE,0.0);
    glClear(GL_COLOR_BUFFER_BIT);

    // set the background color
    glColor4f(0.0f, 1.0f, 0.0f, 0.0f);

    // show the list of active vehicles
    NET.display_active_vehicles();

    // mark the vehicle screen as in need for update
    glFlush();

    // come back to the main window
    glutSetWindow(WindowMain);
}

void display_paxes(void)
{
    //std::cout << "START DISPLAY PAX" << std::endl;
    // set the focus to the window paxes
    glutSetWindow(WindowPaxes);

    // update window title
    char TitlePaxes[256];
    sprintf(TitlePaxes,"Paxes in System at Time %.1f",NET.CURRENT_TIME);
    glutSetWindowTitle(TitlePaxes);

    //Clear all pixels
    glClearColor(BUSSIM_BGCOLOR_VEHICLES_RED,BUSSIM_BGCOLOR_VEHICLES_GREEN,BUSSIM_BGCOLOR_VEHICLES_BLUE,0.0);
    glClear(GL_COLOR_BUFFER_BIT);

    // set the background color
    glColor4f(0.0f, 1.0f, 0.0f, 0.0f);

    // show the list of active paxes
    NET.fill_passenger_window();

    // mark the current windows as in need for an update
    glFlush();

    // go back to the main window
    glutSetWindow(WindowMain);

    //std::cout << "END DISPLAY PAX" << std::endl;
}

void tasten_vehicles( unsigned char key, int x, int y )
{
}

void time_loop_vehicles(int passed_value)
{
    // this defines the automatic mode
    if( AUTOMATIC_MODE > 0 )
    {
        if( NET.SIMULATION_COMPLETE < 1 )
            NET.CURRENT_TIME += BUSSIM_TIME_STEP;
        GLOBAL_COUNTER++;

    }

    //glutPostRedisplay();
    glutTimerFunc(1000.0/NET.SPEEDUP_FACTOR, time_loop, 1);
    glutPostRedisplay();
}

// this is the main screen update method
void display(void)
{
    if( (TASTE_GEDRUECKT > 0))
        if( AUTOMATIC_MODE < 1)
            update_line_list_menue();

    if( (TASTE_GEDRUECKT > 0) || (AUTOMATIC_MODE > 0) )
    {
        if( MOVE_CAMERA_POSITION > 0 )
        {
            if( MOVE_CAMERA_POSITION == 1)
            {
                glMatrixMode(GL_MODELVIEW);
                glTranslatef(0,0.01,0);
                MENUE_OFFSET_Y += 0.01;
                NET.Current_MENUE_OFFSET_Y++;
                glPushMatrix();
                glDrawBuffer(GL_MODELVIEW);
                glPopMatrix();
                NET.append_vp_move(BUSSIM_VIEWPORT_UP);
            }
            if( MOVE_CAMERA_POSITION == 2)
            {
                glMatrixMode(GL_MODELVIEW);
                glTranslatef(0.01,0,0);
                MENUE_OFFSET_X += 0.01;
                NET.Current_MENUE_OFFSET_X++;
                glPushMatrix();
                glDrawBuffer(GL_MODELVIEW);
                glPopMatrix();
                NET.append_vp_move(BUSSIM_VIEWPORT_RIGHT);
            }
            if( MOVE_CAMERA_POSITION == 3)
            {
                glMatrixMode(GL_MODELVIEW);
                glTranslatef(0,-0.01,0);
                MENUE_OFFSET_Y -= 0.01;
                NET.Current_MENUE_OFFSET_Y -= 0.1;
                glPushMatrix();
                glDrawBuffer(GL_MODELVIEW);
                glPopMatrix();
                NET.append_vp_move(BUSSIM_VIEWPORT_DOWN);
            }
            if( MOVE_CAMERA_POSITION == 4)
            {
                glMatrixMode(GL_MODELVIEW);
                glTranslatef(-0.01,0,0);
                MENUE_OFFSET_X -= 0.01;
                NET.Current_MENUE_OFFSET_X -= 0.1;
                glPushMatrix();
                glDrawBuffer(GL_MODELVIEW);
                glPopMatrix();
                NET.append_vp_move(BUSSIM_VIEWPORT_LEFT);
            }
            if( MOVE_CAMERA_POSITION == 5)
            {
                glMatrixMode(GL_MODELVIEW);
                MENUE_OFFSET_X = 0.0;
                MENUE_OFFSET_Y = 0.0;
                NET.Current_MENUE_OFFSET_X = 0.0;
                NET.Current_MENUE_OFFSET_Y = 0.0;
                glLoadIdentity();
                glPushMatrix();
                glDrawBuffer(GL_MODELVIEW);
                glPopMatrix();
                NET.clear_vp_move_list();
            }
            MOVE_CAMERA_POSITION = 0;
        }
        if( MODIFY_ZOOM > 0 )
        {
            if( MODIFY_ZOOM == 7)
            {
                if( NET.Current_Zoom_Level > 0 )
                {
                    glPushName(12);
                    glMatrixMode(GL_MODELVIEW);
                    glScalef(1.0/1.05,1.0/1.05,1);
                    glPushMatrix();
                    glDrawBuffer(GL_MODELVIEW);
                    glPopMatrix();
                    glPushName(11);
                    NET.Current_Zoom_Level--;
                    NET.append_vp_move(BUSSIM_VIEWPORT_OUT);
                }
            }
            if( MODIFY_ZOOM == 8)
            {
                if( NET.Current_Zoom_Level < 100 )
                {
                    glMatrixMode(GL_MODELVIEW);
                    glScalef(1.05,1.05,1);
                    glPushMatrix();
                    glDrawBuffer(GL_MODELVIEW);
                    glPopMatrix();
                    NET.Current_Zoom_Level++;
                    NET.append_vp_move(BUSSIM_VIEWPORT_IN);
                }
            }
            /*
            if( MODIFY_ZOOM == 9)
            {
                glMatrixMode(GL_MODELVIEW);
                glLoadIdentity();
                glPushMatrix();
                glDrawBuffer(GL_MODELVIEW);
                glPopMatrix();
                NET.Current_Zoom_Level=0;
            }
            */
            if( MODIFY_ZOOM == 5)
            {
                glMatrixMode(GL_MODELVIEW);
                glLoadIdentity();
                glPushMatrix();
                glDrawBuffer(GL_MODELVIEW);
                glPopMatrix();
                NET.Current_Zoom_Level=0;
                NET.clear_vp_move_list();
            }
            MODIFY_ZOOM = 0;
        }

        // update the passenger lists
        //std::cout << "START UPDATE PAX LISTS" << std::endl;
        NET.update_paxlists();
        //std::cout << "ENDE UPDATE PAX LISTS" << std::endl;

        // update the walking pax positions
        //std::cout << "START UPDATE WALKING PAX" << std::endl;
        NET.update_walking_paxes();
        //std::cout << "ENDE UPDATE WALKING PAX" << std::endl;

        glClearColor(BUSSIM_BGCOLOR_MAIN_RED,BUSSIM_BGCOLOR_MAIN_GREEN,BUSSIM_BGCOLOR_MAIN_BLUE,0.0);
        glClear(GL_COLOR_BUFFER_BIT);

        // specify and set the title of the simulation window
        char WindowTitle[256];

        // determine time
        int _STUNDEN = (int)(NET.CURRENT_TIME+BUSSIM_MINUTES_OFFSET) / (int)(60);
        int _MINUTEN = (int)(NET.CURRENT_TIME+BUSSIM_MINUTES_OFFSET) - _STUNDEN*60;

        NET.LAST_HOURS = _STUNDEN;
        NET.LAST_MINUTES = _MINUTEN;

        char SW[256];
        if( _STUNDEN > 9 )
        {
            if( _MINUTEN > 9 )
                sprintf(SW,"%d:%d",_STUNDEN,_MINUTEN);
            else
                sprintf(SW,"%d:0%d",_STUNDEN,_MINUTEN);
        }
        else
        {
            if( _MINUTEN > 9 )
                sprintf(SW,"0%d:%d",_STUNDEN,_MINUTEN);
            else
                sprintf(SW,"0%d:0%d",_STUNDEN,_MINUTEN);
        }
        if( NET.SIMULATION_COMPLETE < 1 )
        {
            if( SHOW_NETWORKSTATISTICS > 0 )
            {
                sprintf(WindowTitle,"Statistics: %d stops - %d nodes - %d arcs - %d lines - %d vehicles | pax: %ld to come - %ld in system -%ld ready",NET.STOPS,NET.POINTS,NET.ARCS,NET.LINES,NET.VEHICLES,NET.PAX_UNKNOWN->get_pax_num(),NET.PAX_IN->get_pax_num(),NET.PAX_ARRIVED->get_pax_num());
            }
            else
            {

                if( NET.BETRIEBS_ENDE < 1)
                    sprintf(WindowTitle,"Stored View Items: %d - Zoom: %d - Cur. Sim Time=%s (%.1f) - Speed-Up Factor=%.1f - %ld stored events - %d bunches detected - x/y: %.2f/%.2f - %ld wait for blocks",NET.Stored_VP_Move_Items, NET.Current_Zoom_Level, SW, NET.CURRENT_TIME,NET.SPEEDUP_FACTOR,NET.EVENTS, NET.DETECTED_BUNCHES, NET.x_factor, NET.y_factor, NET.BLOCK_WAIT);
                else
                    sprintf(WindowTitle,"Stored View Items: %d - Zoom: %d - Cur. Sim Time=%s (%.1f) - Speed-Up Factor=%.1f - %ld stored events - %d bunches detected - x/y: %.2f/%.2f - %.2f\%% progress (closing mode)",NET.Stored_VP_Move_Items, NET.Current_Zoom_Level, SW, NET.CURRENT_TIME,NET.SPEEDUP_FACTOR,NET.EVENTS, NET.DETECTED_BUNCHES, NET.x_factor, NET.y_factor, 100.00);
            }
        }
        else
        {
            sprintf(WindowTitle,"Simulation is over at time %s (%8.1f) - Press <q> to close program",SW,NET.CURRENT_TIME);

        }
        // update displayed information
        glutSetWindowTitle(WindowTitle);

       //Clear all pixels
        glClear(GL_COLOR_BUFFER_BIT);

        //load the windows identity
        // glLoadName(12);

        // try to set the background texture
        #ifdef BUSSIM_EXTERN_SOIL
        if( (SHOW_BG > 0) && (NET.BGTextureId > 0) )
        {
            GLfloat xpos;
            GLfloat ypos;
            glMatrixMode(GL_MODELVIEW);
            glPushMatrix();
            glViewport(1,0,1000,1000);
            glLoadIdentity();
            glDisable(GL_LIGHTING);
            glColor3f(1,1,1);
            glEnable(GL_TEXTURE_2D);
            glBindTexture(GL_TEXTURE_2D, NET.BGTextureId);
            glBegin(GL_QUADS);
            glTexCoord2f(0.00f, 0.00f);
            xpos = (GLfloat)((-1.0 + MENUE_OFFSET_X)*pow(1.05,NET.Current_Zoom_Level));
            ypos = (GLfloat)((1.0 + MENUE_OFFSET_Y)*pow(1.05,NET.Current_Zoom_Level));
            glVertex2f((xpos), (ypos));
            glTexCoord2f(0.00f, 1.0f);
            xpos = (GLfloat)((-1.0 + MENUE_OFFSET_X)*pow(1.05,NET.Current_Zoom_Level));
            ypos = (GLfloat)((-1.0 + MENUE_OFFSET_Y)*pow(1.05,NET.Current_Zoom_Level));
            glVertex2f((xpos), (ypos) );
            glTexCoord2f(1.0f, 1.0f);
            xpos = (GLfloat)((1.0 + MENUE_OFFSET_X)*pow(1.05,NET.Current_Zoom_Level));
            ypos = (GLfloat)((-1.0 + MENUE_OFFSET_Y)*pow(1.05,NET.Current_Zoom_Level));
            glVertex2f((xpos), (ypos) );
            glTexCoord2f(1.0-0.00f, 0.00f);
            xpos = (GLfloat)((1.0 + MENUE_OFFSET_X)*pow(1.05,NET.Current_Zoom_Level));
            ypos = (GLfloat)((1.0 + MENUE_OFFSET_Y)*pow(1.05,NET.Current_Zoom_Level));
            glVertex2f((xpos), (ypos) );
            glEnd();
            glDisable(GL_TEXTURE_2D);
            glPopMatrix();
            //glPopMatrix();
        }
        #else
        #endif // BUSSIM_EXTERN_SOIL

        //draw the landscape
        if( SHOW_TOIS > 0 )
            NET.draw_tois();

        // this is the global color (used e.g. for the text)
        glColor4f(0.0f,1.0f,0.0f,0.0f);

        // print the bunch points
        if( SHOW_BUNCHES > 0)
            NET.print_bunch_points();

        // draw the depot nodes
        //if( SHOW_STOPS > 0 )
        //    NET.draw_depots(&NET);

        // draw service arcs
        //NET.draw_service_arcs();

        // set the standard line width
        glLineWidth((GLfloat)(1));

        // display the arcs
        for(int j=0 ; j < NET.ARCS ; j++)
        {
            glColor4f(0.0f, 1.0f, 0.0f, 0.0f);
            glLineWidth((GLfloat)(2));
            if( SHOW_INFRASTRUCTURE > 0)
            {
                if ( SHOW_ARROW_HEADS > 0 )
                    NET.ARC[j].print_on_screen(&NET);
                else
                    NET.ARC[j].print_on_screen_no_heads(&NET);
                if( SHOW_ALSO_TRANSFER_ARCS > 0)
                    NET.ARC[j].print_transfer_arc(&NET);
                else
                {

                }
                if( SHOW_ARC_LABELS > 0 )
                    NET.ARC[j].print_label(&NET);

            }

            if( SHOW_QUEUES > 0 )
                NET.ARC[j].print_queue_on_screen(&NET);
            glLineWidth((GLfloat)(1));
            glColor4f(1.0f, 0.0f, 0.0f, 0.0f);
        }

        // display the lines
        if( SHOW_LINES > 0 )
        {
            for(int j=0 ; j < NET.LINES ; j++)
            {
                glColor4f(NET.LINE[j].RED, NET.LINE[j].GREEN, NET.LINE[j].BLUE, 0.0f);
                glLineWidth((GLfloat)(5));
                NET.LINE[j].print_on_screen(&NET);
                if (SHOW_DIRECTION_INDICATORS > 0)
                    NET.LINE[j].print_on_screen_indicators(&NET);
                glLineWidth((GLfloat)(1));
                glColor4f(1.0f, 0.0f, 0.0f, 0.0f);
            }
        }

        // set the vehicles visibility
        NET.set_visibility();

        // printing the menu

        // check if additional vehicles are starting their daily work
        //NET.start_rotations();
        NET.start_schedules();


        // update the vehicle position
        for(int k=0 ; k < NET.VEHICLES ; k++)
        {
            NET.VEHICLE[k].update_new(&NET);
        }

        // print the stops if wanted
        glColor4f(0.0f, 0.0f, 0.0f, 0.0f);

        for(int j=0 ; j < NET.POINTS ; j++)
        {
            if( SHOW_STOPS > 0)
            {
                glColor4f(0.0f, 1.0f, 0.0f, 0.0f);
                if( NET.PT[j].INFRASTRUCTURE < 1 )
                    NET.PT[j].print_on_screen_small(&NET);

            }
            if( SHOW_STOPS > 0 )
            {
                glColor4f(0.0f, 0.0f, 0.0f, 0.0f);
                if( NET.PT[j].INFRASTRUCTURE < 1 )
                {
                    if( PRINT_SHORT_NODE_LABELS < 1)
                        NET.PT[j].print_label_on_screen(&NET);
                    else
                        NET.PT[j].print_label_on_screen_short(&NET);
                }
            }
            if( SHOW_AUX_STOPS > 0)
            {
                glColor4f(0.0f, 1.0f, 0.0f, 0.0f);
                if( NET.PT[j].INFRASTRUCTURE > 0 )
                    NET.PT[j].print_on_screen_small(&NET);
            }
            if( SHOW_AUX_STOPS_LABELS > 0 )
            {
                glColor4f(0.0f, 0.0f, 0.0f, 0.0f);
                if( NET.PT[j].INFRASTRUCTURE > 0 )
                {
                    if( PRINT_SHORT_NODE_LABELS < 1)
                        NET.PT[j].print_label_on_screen(&NET);
                    else
                        NET.PT[j].print_label_on_screen_short(&NET);
                }
            }
        }

        // print the line agenda
        if( SHOW_LINE_AGENDA > 0)
        {


            int LINE_CNTR=0;
        for(int l=0 ; l < NET.LINES ; l++)
        {
            //if( NET.LINE[l].type == BUSSIM_REGULARLINE )
            if( 1 < 2 )
            {
                glColor4f(NET.LINE[l].RED, NET.LINE[l].GREEN, NET.LINE[l].BLUE, 0.0f);
                glRasterPos2d(-0.9, +0.8 - 0.05*LINE_CNTR);
                char S[256];
                sprintf(S,"%d: %s (%d) - %d stops %d arcs",NET.LINE[l].ID, NET.LINE[l].LineName,NET.LINE[l].displayed,NET.LINE[l].REGULAR_STOP_NUM, NET.LINE[l].ARCS);
                unsigned char* ubuf = reinterpret_cast<unsigned char*>(S);
                glutBitmapString(GLUT_BITMAP_HELVETICA_12, ubuf);
                glColor4f(1.0f, 0.0f, 0.0f, 0.0f);
                LINE_CNTR++;
            }

        }
        }
        // print the active vehicles on its current position
        if( DISPLAY_VEHICLES > 0 )
        {
            for(int k=0 ; k < NET.VEHICLES ; k++)
            {
                if( NET.VEHICLE[k].VISIBLE > 0 )
                {
                    glColor4f(NET.LINE[NET.VEHICLE[k].on_line].RED, NET.LINE[NET.VEHICLE[k].on_line].GREEN, NET.LINE[NET.VEHICLE[k].on_line].BLUE, 0.0f);
                    NET.VEHICLE[k].print_on_screen(&NET);
                    glColor4f(1.0f, 0.0f, 0.0f, 0.0f);
                }
            }
        }

        // start terminating the simulation
        if( NET.CURRENT_TIME >= BUSSIM_END_OF_DUTY )
            NET.BETRIEBS_ENDE = 1;

        // show the list of active vehicles
        //if( SHOW_ACTIVE_VEHICLES > 0)
        //{
        //    glColor4f(0.0f, 1.0f, 0.0f, 0.0f);
        //    NET.display_active_vehicles();
        //}

        // display the clock on the screen

        if( NET.SIMULATION_COMPLETE < 1 )
        {
            /*
            int _STUNDEN = (int)(NET.CURRENT_TIME+BUSSIM_MINUTES_OFFSET) / (int)(60);
            int _MINUTEN = (int)(NET.CURRENT_TIME+BUSSIM_MINUTES_OFFSET) - _STUNDEN*60;

            NET.LAST_HOURS = _STUNDEN;
            NET.LAST_MINUTES = _MINUTEN;

            char SW[256];
            if( _STUNDEN > 9 )
            {
                if( _MINUTEN > 9 )
                    sprintf(SW,"%d:%d",_STUNDEN,_MINUTEN);
                else
                    sprintf(SW,"%d:0%d",_STUNDEN,_MINUTEN);
            }
            else
            {
                if( _MINUTEN > 9 )
                    sprintf(SW,"0%d:%d",_STUNDEN,_MINUTEN);
                else
                    sprintf(SW,"0%d:0%d",_STUNDEN,_MINUTEN);
            }

            // fix clock position
            double CLOCK_X_POS;
            CLOCK_X_POS = BUSSIM_CLOCK_POS_X;
            // clock box
            glColor3f(0.0f, 0.0f, 0.0f);
            glBegin(GL_POLYGON);
                glVertex2f(CLOCK_X_POS-0.01, BUSSIM_CLOCK_POS_Y-0.01);
                glVertex2f(CLOCK_X_POS-0.01, BUSSIM_CLOCK_POS_Y+0.05);
                glVertex2f(CLOCK_X_POS+0.12, BUSSIM_CLOCK_POS_Y+0.05);
                glVertex2f(CLOCK_X_POS+0.12, BUSSIM_CLOCK_POS_Y-0.01);
                glVertex2f(CLOCK_X_POS-0.01, BUSSIM_CLOCK_POS_Y-0.01);
            glEnd();
            unsigned char* ubufA = reinterpret_cast<unsigned char*>(SW);
            glColor3f(1.0f, 1.0f, 1.0f);

            glRasterPos2d(CLOCK_X_POS, BUSSIM_CLOCK_POS_Y);
            glutBitmapString(GLUT_BITMAP_TIMES_ROMAN_24, ubufA);
            */
        }
        else
        {
            /*
            char SW[256];
            if( NET.LAST_HOURS > 9 )
            {
                if( NET.LAST_MINUTES > 9 )
                    sprintf(SW,"%d:%d",NET.LAST_HOURS,NET.LAST_MINUTES);
                else
                    sprintf(SW,"%d:0%d",NET.LAST_HOURS,NET.LAST_MINUTES);
            }
            else
            {
                if( NET.LAST_MINUTES > 9 )
                    sprintf(SW,"0%d:%d",NET.LAST_HOURS,NET.LAST_MINUTES);
                else
                    sprintf(SW,"0%d:0%d",NET.LAST_HOURS,NET.LAST_MINUTES);
            }
            unsigned char* ubufA = reinterpret_cast<unsigned char*>(SW);
            glColor3f(1.0f, 1.0f, 1.0f);
            glRasterPos2d(BUSSIM_CLOCK_POS_X, BUSSIM_CLOCK_POS_Y);
            glutBitmapString(GLUT_BITMAP_TIMES_ROMAN_24, ubufA);
            */
            char SWB[256];
            sprintf(SWB,"Simulation terminated. Press <q> to close window!");
            unsigned char* ubufAB = reinterpret_cast<unsigned char*>(SWB);
            glColor3f(1.0f, 0.0f, 0.0f);
            glRasterPos2d(-0.5, 0.0);
            glutBitmapString(GLUT_BITMAP_TIMES_ROMAN_24, ubufAB);
            //NET.PT[375].WAITINGLIST[9]->print();
            //NET.PT[504].WAITINGLIST[12]->print();
        }


        if( NET.PAX_IN->get_pax_num() > 0 )
        {
            //NET.PAX_IN->get_first_pax()->TravelPath->print_on_screen(&NET);
            //NET.PT[NET.PAX_IN->get_first_pax()->Origin_Node].print_waiting_lists(-0.8, 0.8, &NET);
            //NET.PAX_WALKING->print();
        }


        // update the graphic screen
        glutSetWindow(WindowMain);
        glFlush();


        //glutPostRedisplay();
            glutSetWindow(WindowVehicles);
            //glViewport(1000,0,300,1000);
            //glFlush();
            glutPostRedisplay();

            if( BUSSIM_SHOW_PAX_WINDOW > 0 )
            {


            //glutPostRedisplay();
            glutSetWindow(WindowPaxes);
            //glViewport(1300,0,300,1000);
            //glFlush();
            glutPostRedisplay();
            }

        glutSetWindow(WindowMain);

        //glutPostRedisplay();

        // check if the simulation has been completed
        //std::cout << "SIM_STA=" << NET.SIMULATION_COMPLETE << "\t" << NET.number_of_active_vehicles() << std::endl;
        if( NET.CURRENT_TIME > 0 )
            if( NET.VEHICLES > 0)
                if( NET.number_of_active_vehicles() == 0 )
                {
                    //NET.print_event_list();

                    if( NET.SIMULATION_COMPLETE < 1 )
                    {
                        //NET.save_protocol();
                        NET.SIMULATION_COMPLETE = 1;
                    }

                    // cin;
                    // exit( EXIT_SUCCESS );
                }

        // print the passenger path
        //glutSetWindow(WindowMain);
        //glFlush();
        //glutSetWindow(WindowMain);
        //glutPostRedisplay();

        // reset keyboard cache
        TASTE_GEDRUECKT = 0;
    }
}


void tasten( unsigned char key, int x, int y )
{
    // here we receive and process the callback information from the keyboard
    switch( key ) {
    case 'q' :
        //NET.print_event_list();
        if( NET.SIMULATION_COMPLETE < 1 )
        {
            NET.save_protocol();
        }
        else
        {
            NET.save_protocol();
            NET.SIMULATION_COMPLETE = 1;
        }
        exit( EXIT_SUCCESS );
    break;
    case '+':
        TASTE_GEDRUECKT = 1;
        if( NET.SIMULATION_COMPLETE < 1 )
        NET.CURRENT_TIME += BUSSIM_TIME_STEP;
        GLOBAL_COUNTER++;
    break;
    case 'a':
        GLOBAL_COUNTER++;
        AUTOMATIC_MODE = 1;
    break;
    case 'n':
        GLOBAL_COUNTER++;
        PRINT_SHORT_NODE_LABELS++;
        PRINT_SHORT_NODE_LABELS = PRINT_SHORT_NODE_LABELS % 2;
    break;
    case 'm':
         GLOBAL_COUNTER++;
        AUTOMATIC_MODE = 0;
    break;
    case 'f':
        GLOBAL_COUNTER++;
        NET.SPEEDUP_FACTOR++;
    break;
    case 's':
       GLOBAL_COUNTER++;
        NET.SPEEDUP_FACTOR--;
        if( NET.SPEEDUP_FACTOR < 1 )
            NET.SPEEDUP_FACTOR = 1.0;
    break;
    case 'i':
        GLOBAL_COUNTER++;
        SHOW_INFRASTRUCTURE++;
        SHOW_INFRASTRUCTURE = SHOW_INFRASTRUCTURE % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 'L':
        GLOBAL_COUNTER++;
        SHOW_LINES++;
        SHOW_LINES = SHOW_LINES % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 'S':
        GLOBAL_COUNTER++;
        SHOW_STOPS++;
        SHOW_STOPS = SHOW_STOPS % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 'I':
        GLOBAL_COUNTER++;
        SHOW_AUX_STOPS++;
        SHOW_AUX_STOPS = SHOW_AUX_STOPS % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 'X':
        GLOBAL_COUNTER++;
        SHOW_AUX_STOPS_LABELS++;
        SHOW_AUX_STOPS_LABELS = SHOW_AUX_STOPS_LABELS % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 'A':
        GLOBAL_COUNTER++;
        SHOW_LINE_AGENDA++;
        SHOW_LINE_AGENDA = SHOW_LINE_AGENDA % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 'T':
        GLOBAL_COUNTER++;
        SHOW_TOIS++;
        SHOW_TOIS = SHOW_TOIS % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 'V':
        GLOBAL_COUNTER++;
        SHOW_ACTIVE_VEHICLES++;
        SHOW_ACTIVE_VEHICLES = SHOW_ACTIVE_VEHICLES % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 'v':
        GLOBAL_COUNTER++;
        DISPLAY_VEHICLE_LABELS++;
        DISPLAY_VEHICLE_LABELS = DISPLAY_VEHICLE_LABELS % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 'M':
        GLOBAL_COUNTER++;
        SHOW_MENUE++;
        SHOW_MENUE = SHOW_MENUE % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 'H':
        GLOBAL_COUNTER++;
        SHOW_ARROW_HEADS++;
        SHOW_ARROW_HEADS = SHOW_ARROW_HEADS % 2;
        TASTE_GEDRUECKT = 1;
    break;

    case 'F':
        GLOBAL_COUNTER++;
        DISPLAY_VEHICLES++;
        DISPLAY_VEHICLES = DISPLAY_VEHICLES % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 'B':
        GLOBAL_COUNTER++;
        SHOW_BUNCHES++;
        SHOW_BUNCHES = SHOW_BUNCHES % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case '5':
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 5;
        MODIFY_ZOOM = 5;
        TASTE_GEDRUECKT = 1;
    break;
        case '1':
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 1;
        TASTE_GEDRUECKT = 1;
    break;
        case '2':
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 2;
        TASTE_GEDRUECKT = 1;
    break;
        case '3':
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 3;
        TASTE_GEDRUECKT = 1;
    break;
        case '4':
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 4;
        TASTE_GEDRUECKT = 1;
    break;
        case '7':
        GLOBAL_COUNTER++;
        MODIFY_ZOOM = 7;
        TASTE_GEDRUECKT = 1;
    break;
        case '8':
        GLOBAL_COUNTER++;
        MODIFY_ZOOM = 8;
        TASTE_GEDRUECKT = 1;
    break;
        case '9':
        GLOBAL_COUNTER++;
        MODIFY_ZOOM = 9;
        TASTE_GEDRUECKT = 1;
    break;
        case 'N':
        SHOW_NETWORKSTATISTICS++;
        SHOW_NETWORKSTATISTICS = SHOW_NETWORKSTATISTICS % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 'W':
        SHOW_QUEUES++;
        SHOW_QUEUES = SHOW_QUEUES % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 'U':
        SHOW_ALSO_TRANSFER_ARCS++;
        SHOW_ALSO_TRANSFER_ARCS = SHOW_ALSO_TRANSFER_ARCS % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 'D':
            if( SHOW_LINES > 0)
            {
                SHOW_DIRECTION_INDICATORS++;
                SHOW_DIRECTION_INDICATORS = SHOW_DIRECTION_INDICATORS % 2;
                TASTE_GEDRUECKT = 1;
            }
    break;
        case 'G':
        SHOW_BG++;
        SHOW_BG = SHOW_BG % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 'l':
        SHOW_ARC_LABELS++;
        SHOW_ARC_LABELS = SHOW_ARC_LABELS % 2;
        TASTE_GEDRUECKT = 1;

    }

    glutPostRedisplay();
}

void create_menue(void)
{
    glutCreateMenu(menu);
    glutAddMenuEntry("<q> quit",0);
    glutAddMenuEntry("<+> manual time step",1);
    glutAddMenuEntry("<a> enable automatic mode",2);
    glutAddMenuEntry("<m> stop automatic mode",3);
    glutAddMenuEntry("<f> increase speedup factor",4);
    glutAddMenuEntry("<s> increase speedup factor",5);
    //glutAddMenuEntry("------------------------",-1);
    glutAddMenuEntry("<i> show infrastructure",6);
    glutAddMenuEntry("<U> show also transfer arcs",90);
    glutAddMenuEntry("<H> show arrow heads",71);
    glutAddMenuEntry("<S> show platform names",8);
    glutAddMenuEntry("<X> show switches and track point names",70);
    glutAddMenuEntry("<I> show switches and other track points",60);
    glutAddMenuEntry("<n> print all node labels in short version",91);
    glutAddMenuEntry("<L> show lines",7);
    glutAddMenuEntry("<l> show arc labels",42);
    glutAddMenuEntry("<A> display line agenda",9);
    glutAddMenuEntry("<F> show the active vehicles",50);
    glutAddMenuEntry("<V> display list of active vehicles",10);
    glutAddMenuEntry("<v> show vehicle labels",41);
    glutAddMenuEntry("<B> print bunching points",12);
    glutAddMenuEntry("<N> switch information in window title",13);
    glutAddMenuEntry("<T> show tois",14);
    #ifdef BUSSIM_EXTERN_SOIL
        glutAddMenuEntry("<G> show the background texture",51);
    #endif // BUSSIM_EXTERN_SOIL
    if( SHOW_LINES > 0 )
        glutAddMenuEntry("<D> show direction indicators",15);
    glutAddMenuEntry("<W> show queues on arcs",16);
    glutAddMenuEntry("<5> restore all view settings",20);
    glutAddMenuEntry("<1> move left",21);
    glutAddMenuEntry("<2> move up",22);
    glutAddMenuEntry("<3> move right",23);
    glutAddMenuEntry("<4> move down",24);

    glutAddMenuEntry("<7> zoom out",30);
    glutAddMenuEntry("<8> zoom in",31);
    glutAttachMenu(GLUT_RIGHT_BUTTON);

    // create the line menue to un/hide individual lines
    char TMP[256];
    glutCreateMenu(menu_a);
    for( int l=0 ; l < NET.LINES ; l++ )
    {
        if( NET.LINE[l].displayed > 0)
            sprintf(TMP,"hide line %d (%s)\n",NET.LINE[l].ID,NET.LINE[l].LineName);
        else
            sprintf(TMP,"unhide line %d (%s)\n",NET.LINE[l].ID,NET.LINE[l].LineName);
        glutAddMenuEntry(TMP,1000+l);
    }
    sprintf(TMP,"hide all %d lines\n",NET.LINES);
    glutAddMenuEntry(TMP,NET.LINES);

    sprintf(TMP,"unhide all %d lines\n",NET.LINES);
    glutAddMenuEntry(TMP,NET.LINES+1);
    glutAttachMenu(GLUT_MIDDLE_BUTTON);

    glutSetWindow(glutGetWindow());
}

void menu_a(int id)
{

    // un/hiding lines
    for( int l=0 ; l < NET.LINES ; l++ )
    {
        if( id == 1000+l)
        {
            GLOBAL_COUNTER++;
            NET.LINE[l].displayed++;
            NET.LINE[l].displayed = NET.LINE[l].displayed % 2;

            TASTE_GEDRUECKT = 1;
            l = NET.LINES+1;
            //glutChangeToMenuEntry()
            //glutChangeToMenuEntry(l, "neu", id);
            //glutSetMenu(&this);
        }

    }
    if( id== NET.LINES )
    {
        // hide all lines
        for( int l=0 ; l < NET.LINES ; l++ )
            NET.LINE[l].displayed = 0;
    }
    if( id== NET.LINES+1 )
    {
        // unhide all lines
        for( int l=0 ; l < NET.LINES ; l++ )
            NET.LINE[l].displayed = 1;
    }
}

void menu(int id)
{
   switch(id)
   {

    case 0 :  // <q>
        //NET.print_event_list();
        NET.save_protocol();
        exit( EXIT_SUCCESS );
    break;
    case 1:   // <+>
        TASTE_GEDRUECKT = 1;
        if( NET.SIMULATION_COMPLETE < 1 )
            NET.CURRENT_TIME += BUSSIM_TIME_STEP;
        GLOBAL_COUNTER++;
    break;
    case 2:   // <a>
        GLOBAL_COUNTER++;
        AUTOMATIC_MODE = 1;
    break;
    case 3:   // <m>
         GLOBAL_COUNTER++;
        AUTOMATIC_MODE = 0;
    break;
    case 4:   // <f>
        GLOBAL_COUNTER++;
        NET.SPEEDUP_FACTOR++;
    break;
    case 5:   // <s>
       GLOBAL_COUNTER++;
        NET.SPEEDUP_FACTOR--;
        if( NET.SPEEDUP_FACTOR < 1 )
            NET.SPEEDUP_FACTOR = 1.0;
    break;
    case 6:   // <i>
        GLOBAL_COUNTER++;
        SHOW_INFRASTRUCTURE++;
        SHOW_INFRASTRUCTURE = SHOW_INFRASTRUCTURE % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 7:   // <L>
        GLOBAL_COUNTER++;
        SHOW_LINES++;
        SHOW_LINES = SHOW_LINES % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 50:   // <L>
        GLOBAL_COUNTER++;
        DISPLAY_VEHICLES++;
        DISPLAY_VEHICLES = DISPLAY_VEHICLES % 2;

        TASTE_GEDRUECKT = 1;
    break;
    case 8:   // <S>
        GLOBAL_COUNTER++;
        SHOW_STOPS++;
        SHOW_STOPS = SHOW_STOPS % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 60:   // <S>
        GLOBAL_COUNTER++;
        SHOW_AUX_STOPS++;
        SHOW_AUX_STOPS = SHOW_AUX_STOPS % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 70:   // <S>
        GLOBAL_COUNTER++;
        SHOW_AUX_STOPS_LABELS++;
        SHOW_AUX_STOPS_LABELS = SHOW_AUX_STOPS_LABELS % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 71:   // <H>
        GLOBAL_COUNTER++;
        SHOW_ARROW_HEADS++;
        SHOW_ARROW_HEADS = SHOW_ARROW_HEADS % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 9:   // <A>
        GLOBAL_COUNTER++;
        SHOW_LINE_AGENDA++;
        SHOW_LINE_AGENDA = SHOW_LINE_AGENDA % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 10:   // <V>
        GLOBAL_COUNTER++;
        SHOW_ACTIVE_VEHICLES++;
        SHOW_ACTIVE_VEHICLES = SHOW_ACTIVE_VEHICLES % 2;


        TASTE_GEDRUECKT = 1;
    break;
    case 11:   // <M>
        GLOBAL_COUNTER++;
        SHOW_MENUE++;
        SHOW_MENUE = SHOW_MENUE % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 12: // <B>
        GLOBAL_COUNTER++;
        SHOW_BUNCHES++;
        SHOW_BUNCHES = SHOW_BUNCHES % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 13:   // <N>
        GLOBAL_COUNTER++;
        SHOW_NETWORKSTATISTICS++;
        SHOW_NETWORKSTATISTICS = SHOW_NETWORKSTATISTICS % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 14:   // <T>
        GLOBAL_COUNTER++;
        SHOW_TOIS++;
        SHOW_TOIS = SHOW_TOIS % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 15:   // <T>
        GLOBAL_COUNTER++;
        SHOW_DIRECTION_INDICATORS++;
        SHOW_DIRECTION_INDICATORS = SHOW_DIRECTION_INDICATORS % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 16:   // <T>
        GLOBAL_COUNTER++;
        SHOW_QUEUES++;
        SHOW_QUEUES = SHOW_QUEUES % 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 20:  // <5>
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 5;
        TASTE_GEDRUECKT = 1;
    break;
        case 21:   // <1>
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 1;
        TASTE_GEDRUECKT = 1;
    break;
        case 22:   // <2>
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 2;
        TASTE_GEDRUECKT = 1;
    break;
        case 23:   // <3>
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 3;
        TASTE_GEDRUECKT = 1;
    break;
        case 24:   // <4>
        GLOBAL_COUNTER++;
        MOVE_CAMERA_POSITION = 4;
        TASTE_GEDRUECKT = 1;
    break;
        case 30:   // <7>
        GLOBAL_COUNTER++;
        MODIFY_ZOOM = 7;
        TASTE_GEDRUECKT = 1;
    break;
        case 31:   // <8>
        GLOBAL_COUNTER++;
        MODIFY_ZOOM = 8;
        TASTE_GEDRUECKT = 1;
    break;
        case 32:   // <9>
        GLOBAL_COUNTER++;
        MODIFY_ZOOM = 9;
        TASTE_GEDRUECKT = 1;
    break;
    case 41:   // <v>
        GLOBAL_COUNTER++;
        DISPLAY_VEHICLE_LABELS++;
        DISPLAY_VEHICLE_LABELS = DISPLAY_VEHICLE_LABELS % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 42:   // <l>
        GLOBAL_COUNTER++;
        SHOW_ARC_LABELS++;
        SHOW_ARC_LABELS = SHOW_ARC_LABELS % 2;
        TASTE_GEDRUECKT = 1;
    break;

    case 51:   // <G>
        GLOBAL_COUNTER++;
        SHOW_BG++;
        SHOW_BG = SHOW_BG % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 90:   // <U>
        GLOBAL_COUNTER++;
        SHOW_ALSO_TRANSFER_ARCS++;
        SHOW_ALSO_TRANSFER_ARCS = SHOW_ALSO_TRANSFER_ARCS % 2;
        TASTE_GEDRUECKT = 1;
    break;
    case 91:   // <n>
        GLOBAL_COUNTER++;
        PRINT_SHORT_NODE_LABELS++;
        PRINT_SHORT_NODE_LABELS = PRINT_SHORT_NODE_LABELS % 2;
        TASTE_GEDRUECKT = 1;
    break;
   }
}

void time_loop(int passed_value)
{
    // this defines the automatic mode
    if( AUTOMATIC_MODE > 0 )
    {
        if( NET.SIMULATION_COMPLETE < 1 )
            NET.CURRENT_TIME += BUSSIM_TIME_STEP;
        GLOBAL_COUNTER++;

    }
    //glutPostRedisplay();
    glutTimerFunc(1000.0/NET.SPEEDUP_FACTOR, time_loop, 1);
    glutPostRedisplay();
}

void update_line_list_menue()
{
    char TMP[256];

    int men;
    men = glutGetMenu();
    for( int l=0 ; l < NET.LINES ; l++ )
    {
        if( NET.LINE[l].displayed > 0)
            sprintf(TMP,"hide line %d (%s)\n",NET.LINE[l].ID,NET.LINE[l].LineName);
        else
            sprintf(TMP,"unhide line %d (%s)\n",NET.LINE[l].ID,NET.LINE[l].LineName);
        //glutAddMenuEntry(TMP,1000+l);
        glutChangeToMenuEntry(1+l,TMP,1000+l);

    }
    //glut
    glutSetMenu(men);
}
