#include "bussim_global.h"

BUSSIM_STOP::BUSSIM_STOP()
{
    // the constructor
    this->ID = -1;
    this->STOP_NAME = "undefined";
    this->STOP_SHORT_NAME = "undefined";
    this->first_point = nullptr;
    this->last_point = nullptr;

    this->first_arc = nullptr;
    this->last_arc = nullptr;

    this->first_inbound_arc = nullptr;
    this->last_inbound_arc = nullptr;

    this->first_outbound_arc = nullptr;
    this->last_outbound_arc = nullptr;

    this->ASSIGNED_POINTS = 0;

    this->ASSIGNED_ARCS = 0;
    this->ASSIGNED_INBOUND_ARCS = 0;
    this->ASSIGNED_OUTBOUND_ARCS = 0;

    this->RED = 0.0;
    this->GREEN = 0.0;
    this->BLUE = 0.0;
}

BUSSIM_STOP::~BUSSIM_STOP()
{
    // the destructor
}

void BUSSIM_STOP::specify(long _ID, std::string _STOP_NAME, std::string _STOP_SHORT_NAME)
{
    this->ID = _ID;
    this->STOP_NAME = _STOP_NAME;
    this->STOP_SHORT_NAME = _STOP_SHORT_NAME;
}

void BUSSIM_STOP::append_point(int _ID)
{
    // create a new BUSSIM_ASSIGNED_POINT object
    struct BUSSIM_ASSIGNED_POINT *TMP;
    TMP = new struct BUSSIM_ASSIGNED_POINT;

    TMP->PT_ID = _ID;
    TMP->next = nullptr;
    TMP->ref2stop = this;

    if( this->first_point != nullptr )
    {
        // there are alreday stored points
        this->last_point->next = TMP;
        this->last_point = TMP;
    }
    else
    {
        // store the first point
        this->first_point = TMP;
        this->last_point = TMP;
    }
    TMP = nullptr;

    this->ASSIGNED_POINTS++;
}

void BUSSIM_STOP::append_arc(int _ID)
{
    // create a new BUSSIM_ASSIGNED_POINT object
    struct BUSSIM_ASSIGNED_ARC *TMP;
    TMP = new struct BUSSIM_ASSIGNED_ARC;

    TMP->ARC_ID = _ID;
    TMP->next = nullptr;
    TMP->ref2stop = this;

    if( this->first_arc != nullptr )
    {
        // there are alreday stored points
        this->last_arc->next = TMP;
        this->last_arc = TMP;
    }
    else
    {
        // store the first point
        this->first_arc = TMP;
        this->last_arc = TMP;
    }
    TMP = nullptr;

    this->ASSIGNED_ARCS++;
}

void BUSSIM_STOP::append_inbound_arc(int _ID)
{
    // create a new BUSSIM_ASSIGNED_ARC object
    struct BUSSIM_ASSIGNED_ARC *TMP;
    TMP = new struct BUSSIM_ASSIGNED_ARC;

    TMP->ARC_ID = _ID;
    TMP->next = nullptr;
    TMP->ref2stop = this;

    if( this->first_inbound_arc != nullptr )
    {
        // there are alreday stored points
        this->last_inbound_arc->next = TMP;
        this->last_inbound_arc = TMP;
    }
    else
    {
        // store the first point
        this->first_inbound_arc = TMP;
        this->last_inbound_arc = TMP;
    }
    TMP = nullptr;

    this->ASSIGNED_INBOUND_ARCS++;
}

void BUSSIM_STOP::append_outbound_arc(int _ID)
{
    // create a new BUSSIM_ASSIGNED_ARC object
    struct BUSSIM_ASSIGNED_ARC *TMP;
    TMP = new struct BUSSIM_ASSIGNED_ARC;

    TMP->ARC_ID = _ID;
    TMP->next = nullptr;
    TMP->ref2stop = this;

    if( this->first_outbound_arc != nullptr )
    {
        // there are already stored arcs
        this->last_outbound_arc->next = TMP;
        this->last_outbound_arc = TMP;
    }
    else
    {
        // store the first arc
        this->first_outbound_arc = TMP;
        this->last_outbound_arc = TMP;
    }
    TMP = nullptr;

    this->ASSIGNED_OUTBOUND_ARCS++;
}
