#include <iostream>
#include <stdio.h>
#include <string>


//#include <GL/gl.h>
//#include <freeglut/freeglut.h>

#include "bussim_global.h"

using namespace std;

GLint WindowMain, WindowVehicles, WindowPaxes;


// this is the constructor of the network that stores all simulation data
// first argument: number of stops stored
// second argument: number of stored nodes
// third argument: number of arcs stored
// fourth argument: number of stored blocks
// fifth argument: number of lines
// sixth argument: number of vehicles
// seventh argument: number of stored tois
// eights argument: number of passengers to be moved

class BUSSIM_NETWORK NET(44,461,466,1,2,2,0,0);


int main(int argc, char** argv)
{
    // start the configuration of the network
    NET.specify();

    // configure the random number seeding
    srand(BUSSIM_RANDOM_SEED);

    // create the graphic screen
    glutInit(&argc, argv);
    set_simulation_window();

    // load and print the background
    #ifdef BUSSIM_EXTERN_SOIL
    GLuint tex_2d = SOIL_load_OGL_texture
    (
        BUSSIM_BGFILE,
        SOIL_LOAD_AUTO,
        SOIL_CREATE_NEW_ID,
        SOIL_FLAG_MIPMAPS | SOIL_FLAG_COMPRESS_TO_DXT
    );

    if (0 == tex_2d)
    {
        printf("SOIL loading error: '%s'\n", SOIL_last_result());
     }
    else
        NET.BGTextureId = tex_2d;
    #else
        #pragma "libraray soil not included - map background not available"
    #endif

    // create menue
    create_menue();

    // these are the callback functions
    set_callback_funcs();

    glClearColor(0.0, 0.0, 0.0, 0.0);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    // Start the main loop
    glutMainLoop();

    return 0;
}
